/[svn2cvs]/trunk/svn2cvs.pl
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /trunk/svn2cvs.pl

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 3 by dpavlin, Tue Mar 9 21:45:32 2004 UTC revision 41 by dpavlin, Sat Sep 22 13:52:30 2007 UTC
# Line 8  Line 8 
8  # http://raw.no/personal/blog  # http://raw.no/personal/blog
9  #  #
10  # 2004-03-09 Dobrica Pavlinusic <dpavlin@rot13.org>  # 2004-03-09 Dobrica Pavlinusic <dpavlin@rot13.org>
11    #
12    # documentation is after __END__
13    
14  use strict;  use strict;
15  use File::Temp qw/ tempdir /;  use File::Temp qw/ tempdir /;
16    use File::Path;
17  use Data::Dumper;  use Data::Dumper;
18  use XML::Simple;  use XML::Simple;
19    
20  # get current user home directory  # do we want to sync just part of repository?
21  my $HOME = $ENV{'HOME'} || die "can't get home directory!";  my $partial_import = 1;
22    
23    # do we want to add svk-like prefix with original revision, author and date?
24    my $decorate_commit_message = 1;
25    
26    if ( @ARGV < 2 ) {
27            print "usage: $0 SVN_URL CVSROOT CVSREPOSITORY\n";
28            exit 1;
29    }
30    
31    my ( $SVNROOT, $CVSROOT, $CVSREP ) = @ARGV;
32    
33    if ( $SVNROOT !~ m,^[\w+]+:///*\w+, ) {
34            print "ERROR: invalid svn root $SVNROOT\n";
35            exit 1;
36    }
37    
38    # Ensure File::Temp::END can clean up:
39    $SIG{__DIE__} = sub { chdir("/tmp"); die @_ };
40    
41    my $TMPDIR = tempdir( "/tmp/checkoutXXXXX", CLEANUP => 1 );
42    
43  # cvsroot directory  sub cd_tmp {
44  my $CVSROOT="$HOME/x/cvsroot";          chdir($TMPDIR) || die "can't cd to $TMPDIR: $!";
45  # name of cvs repository to commit to  }
 my $CVSREP="svn2cvs";  
   
 # svnroot directory  
 my $SVNROOT="file://$HOME/private/svn/svn2cvs";  
 # name of respository  
 my $SVNREP="trunk";  
   
 # webpac example  
 #$CVSROOT="$HOME/x/cvsroot";  
 #$CVSREP="webpac";  
 #$SVNROOT="file://$HOME/private/svn/webpac/";  
 #$SVNREP="trunk";  
46    
47  my $TMPDIR=tempdir( "/tmp/checkoutXXXXX", CLEANUP => 1 );  sub cd_rep {
48            chdir("$TMPDIR/$CVSREP") || die "can't cd to $TMPDIR/$CVSREP: $!";
49    }
50    
51  chdir($TMPDIR) || die "can't cd to $TMPDIR: $!";  print "## using TMPDIR $TMPDIR\n";
52    
53  # cvs command with root  # cvs command with root
54  my $cvs="cvs -d $CVSROOT";  my $cvs = "cvs -f -d $CVSROOT";
55    
56    # current revision in CVS
57    my $rev;
58    
59  #  #
60  # sub to do logging and system calls  # sub to do logging and system calls
61  #  #
62  sub log_system($$) {  sub log_system($$) {
63          my ($cmd,$errmsg) = @_;          my ( $cmd, $errmsg ) = @_;
64          print STDERR "## $cmd\n";          print STDERR "## $cmd\n";
65          system $cmd || die "$errmsg: $!";          system($cmd) == 0 || die "$errmsg: $!";
66  }  }
67    
68  #  #
69  # sub to commit .svn rev file later  # sub to commit .svn rev file later
70  #  #
71  sub commit_svnrev {  sub commit_svnrev {
72          my $rev = shift @_;          my $rev     = shift @_;
73          my $add_new = shift @_;          my $add_new = shift @_;
74    
75          die "commit_svnrev needs revision" if (! defined($rev));          die "commit_svnrev needs revision" if ( !defined($rev) );
76    
77          open(SVNREV,"> $CVSREP/.svnrev") || die "can't open $TMPDIR/$CVSREP/.svnrev: $!";          open( SVNREV, "> .svnrev" )
78                    || die "can't open $TMPDIR/$CVSREP/.svnrev: $!";
79          print SVNREV $rev;          print SVNREV $rev;
80          close(SVNREV);          close(SVNREV);
81    
82          my $path=".svnrev";          my $path = ".svnrev";
83    
84          if ($add_new) {          if ($add_new) {
85                  system "$cvs add $CVSREP/$path" || die "cvs add of $path failed: $!";                  system "$cvs add '$path'" || die "cvs add of $path failed: $!";
86            }
87            else {
88                    my $msg = "subversion revision $rev commited to CVS";
89                    print "$msg\n";
90                    system "$cvs commit -m '$msg' '$path'"
91                            || die "cvs commit of $path failed: $!";
92          }          }
   
         my $msg="subversion revision $rev commited to CVS";  
         print "$msg\n";  
         system "$cvs commit -m \"$msg\" $CVSREP/$path" || die "cvs commit of $path failed: $!";  
93  }  }
94    
95    sub add_dir($$) {
96            my ( $path, $msg ) = @_;
97            print "# add_dir($path)\n";
98            die "add_dir($path) is not directory" unless ( -d $path );
99    
100            my $curr_dir;
101    
102            foreach my $d ( split( m#/#, $path ) ) {
103                    $curr_dir .= ( $curr_dir ? '/' : '' ) . $d;
104    
105                    next if in_entries($curr_dir);
106                    next if ( -e "$curr_dir/CVS" );
107    
108                    log_system( "$cvs add '$curr_dir'", "cvs add of $curr_dir failed" );
109            }
110    }
111    
112  # ok, now do the checkout  # ok, now do the checkout
113    eval {
114            cd_tmp;
115            log_system( "$cvs -q checkout $CVSREP", "cvs checkout failed" );
116    };
117    
118  log_system("$cvs -q checkout $CVSREP","cvs checkout failed");  if ($@) {
119            print <<_NEW_REP_;
120    
121  my $rev;  There is no CVS repository '$CVSREP' in your CVS. I will assume that
122    this is import of new module in your CVS and start from revision 0.
123    
124    Press enter to continue importing new CVS repository or CTRL+C to abort.
125    
126    _NEW_REP_
127    
128            print "start import of new module [yes]: ";
129            my $in = <STDIN>;
130            cd_tmp;
131            mkdir($CVSREP) || die "can't create $CVSREP: $!";
132            cd_rep;
133    
134            open( SVNREV, "> .svnrev" ) || die "can't open $CVSREP/.svnrev: $!";
135            print SVNREV "0";
136            close(SVNREV);
137    
138  # check if svnrev exists          $rev = 0;
139  if (! -e "$CVSREP/.svnrev") {  
140          print <<_USAGE_;          # create new module
141            cd_rep;
142            log_system( "$cvs import -d -m 'new CVS module' $CVSREP svn r$rev",
143                    "import of new repository" );
144            cd_tmp;
145            rmtree($CVSREP) || die "can't remove $CVSREP";
146            log_system( "$cvs -q checkout $CVSREP", "cvs checkout failed" );
147            cd_rep;
148    
149    }
150    else {
151    
152            # import into existing module directory in CVS
153    
154            cd_rep;
155    
156            # check if svnrev exists
157            if ( !-e ".svnrev" ) {
158                    print <<_USAGE_;
159    
160  Your CVS repository doesn't have .svnrev file!  Your CVS repository doesn't have .svnrev file!
161    
162  This file is used to keep CVS repository and SubVersion in sync, so  This file is used to keep CVS repository and Subversion in sync, so
163  that only newer changes will be commited.  that only newer changes will be commited.
164    
165  It's quote possible that this is first svn2cvs run for this repository.  It's quote possible that this is first svn2cvs run for this repository.
# Line 96  corresponds to current version of CVS re Line 168  corresponds to current version of CVS re
168  been checkouted.  been checkouted.
169    
170  If you migrated your cvs repository to svn using cvs2svn, this will be  If you migrated your cvs repository to svn using cvs2svn, this will be
171  last SubVersion revision. If this is initial run of conversion of  last Subversion revision. If this is initial run of conversion of
172  SubVersion repository to CVS, correct revision is 0.  Subversion repository to CVS, correct revision is 0.
173    
174  _USAGE_  _USAGE_
175    
176          print "svn revision corresponding to CVS [abort]: ";                  print "svn revision corresponding to CVS [abort]: ";
177          my $in = <STDIN>;                  my $in = <STDIN>;
178          chomp($in);                  chomp($in);
179          if ($in !~ /^\d+$/) {                  if ( $in !~ /^\d+$/ ) {
180                  print "Aborting: revision not a number\n";                          print "Aborting: revision not a number\n";
181                  exit 1;                          exit 1;
182          } else {                  }
183                  $rev = $in;                  else {
184                  commit_svnrev($rev,1);  # create new                          $rev = $in;
185          }                          commit_svnrev( $rev, 1 );    # create new
186  } else {                  }
187          open(SVNREV,"$CVSREP/.svnrev") || die "can't open $TMPDIR/$CVSREP/.svnrev: $!";          }
188          my $rev = <SVNREV>;          else {
189          chomp($rev);                  open( SVNREV, ".svnrev" )
190          close(SVNREV);                          || die "can't open $TMPDIR/$CVSREP/.svnrev: $!";
191  }                  $rev = <SVNREV>;
192                    chomp($rev);
193  print "Starting after revision $rev\n";                  close(SVNREV);
194  $rev++;          }
195    
196            print "Starting after revision $rev\n";
197            $rev++;
198    }
199    
200  #  #
201  # FIXME!! HEAD should really be next verison and loop because this way we  # FIXME!! HEAD should really be next verison and loop because this way we
# Line 129  $rev++; Line 204  $rev++;
204  # case much about accuracy and completnes of logs there, this might  # case much about accuracy and completnes of logs there, this might
205  # be good. YMMV  # be good. YMMV
206  #  #
207  open(LOG, "svn log -r $rev:HEAD -v --xml $SVNROOT/$SVNREP |") || die "svn log for repository $SVNROOT/$SVNREP failed: $!";  open( LOG, "svn log -r $rev:HEAD -v --xml $SVNROOT |" )
208            || die "svn log for repository $SVNROOT failed: $!";
209  my $log;  my $log;
210  while(<LOG>) {  while (<LOG>) {
211          $log .= $_;          $log .= $_;
212  }  }
213  close(LOG);  close(LOG);
214    
215  my $xml = XMLin($log, ForceArray => [ 'logentry', 'path' ]);  my $xml;
216    eval { $xml = XMLin( $log, ForceArray => [ 'logentry', 'path' ] ); };
217    
218    #=begin log_example
219    #
220    #------------------------------------------------------------------------
221    #r256 | dpavlin | 2004-03-09 13:18:17 +0100 (Tue, 09 Mar 2004) | 2 lines
222    #
223    #ported r254 from hidra branch
224    #
225    #=cut
226    
227  =begin log_example  my $fmt = "\n" . "-" x 79 . "\nr%5s| %8s | %s\n\n%s\n";
   
 ------------------------------------------------------------------------  
 r256 | dpavlin | 2004-03-09 13:18:17 +0100 (Tue, 09 Mar 2004) | 2 lines  
228    
229  ported r254 from hidra branch  if ( !$xml->{'logentry'} ) {
230            print "no newer log entries in Subversion repostory. CVS is current\n";
231            exit 0;
232    }
233    
234  =cut  # return all files in CVS/Entries
235    sub entries($) {
236            my $dir = shift;
237            die "entries expects directory argument!" unless -d $dir;
238            my @entries;
239            open( my $fh, "./$dir/CVS/Entries" ) || return 0;
240            while (<$fh>) {
241                    if ( m{^D/([^/]+)}, ) {
242                            my $sub_dir = $1;
243                            warn "#### entries recurse into: $dir/$sub_dir";
244                            push @entries, map {"$sub_dir/$_"} entries("$dir/$sub_dir");
245                            push @entries, $sub_dir;
246                    }
247                    elsif (m{^/([^/]+)/}) {
248                            push @entries, $1;
249                    }
250                    elsif ( !m{^D$} ) {
251                            die "can't decode entries line: $_";
252                    }
253            }
254            close($fh);
255            warn "#### entries($dir) => ", join( "|", @entries );
256            return @entries;
257    }
258    
259  my $fmt = "\n" . "-" x 79 . "\nr%5s| %8s | %s\n\n%s\n";  # check if file exists in CVS/Entries
260    sub in_entries($) {
261            my $path = shift;
262            if ( $path =~ m,^(.*?/*)([^/]+)$, ) {
263                    my ( $dir, $file ) = ( $1, $2 );
264                    if ( $dir !~ m,/$, && $dir ne "" ) {
265                            $dir .= "/";
266                    }
267    
268  if (! $xml->{'logentry'}) {                  open( my $fh, "./$dir/CVS/Entries" )
269          print "no newer log entries in SubVersion repostory. CVS is current\n";                          || return 0;    #die "no entries file: $dir/CVS/Entries";
270          exit 0;                  while (<$fh>) {
271                            return 1 if (m{^/$file/});
272                    }
273                    close($fh);
274                    return 0;
275            }
276            else {
277                    die "can't split '$path' to dir and file!";
278            }
279  }  }
280    
281  print Dumper($xml);  cd_tmp;
282    cd_rep;
283    
284  foreach my $e (@{$xml->{'logentry'}}) {  foreach my $e ( @{ $xml->{'logentry'} } ) {
285          die "BUG: revision from .svnrev ($rev) greater than from subversion (".$e->{'revision'}.")" if ($rev > $e->{'revision'});          die "BUG: revision from .svnrev ($rev) greater than from subversion ("
286                    . $e->{'revision'} . ")"
287                    if ( $rev > $e->{'revision'} );
288          $rev = $e->{'revision'};          $rev = $e->{'revision'};
289          log_system("svn export --force -q -r $rev $SVNROOT/$SVNREP $CVSREP", "svn export of revision $rev failed");          log_system( "svn export --force -q -r $rev $SVNROOT $TMPDIR/$CVSREP",
290                    "svn export of revision $rev failed" );
291    
292          printf($fmt, $e->{'revision'}, $e->{'author'}, $e->{'date'}, $e->{'msg'});          # deduce name of svn directory
293          foreach my $p (@{$e->{'paths'}->{'path'}}) {          my $SVNREP  = "";
294                  my ($action,$path) = ($p->{'action'},$p->{'content'});          my $tmpsvn  = $SVNROOT || die "BUG: SVNROOT empty!";
295            my $tmppath = $e->{'paths'}->{'path'}->[0]->{'content'}
296                    || die "BUG: tmppath empty!";
297            do {
298                    if ( $tmpsvn =~ s#(/[^/]+)/*$## ) {    # vim fix
299                            $SVNREP = $1 . $SVNREP;
300                    }
301                    elsif ( $e->{'paths'}->{'path'}->[0]->{'copyfrom-path'} ) {
302                            print
303                                    "NOTICE: copyfrom outside synced repository ignored - skipping\n";
304                            next;
305                    }
306                    else {
307                            print "NOTICE: can't deduce svn dir from $SVNROOT - skipping\n";
308                            next;
309                    }
310            } until ( $tmppath =~ m/^$SVNREP/ );
311    
312            print "NOTICE: using $SVNREP as directory for svn\n";
313    
314            printf( $fmt,
315                    $e->{'revision'}, $e->{'author'}, $e->{'date'}, $e->{'msg'} );
316            my @commit;
317    
318            my $msg = $e->{'msg'};
319            $msg =~ s/'/'\\''/g;    # quote "
320    
321            $msg = 'r' . $rev . ' ' . $e->{author} . ' | ' . $e->{date} . "\n" . $msg
322                    if $decorate_commit_message;
323    
324            sub cvs_commit {
325                    my $msg = shift || die "no msg?";
326                    if ( !@_ ) {
327                            warn "commit ignored, no files\n";
328                            return;
329                    }
330                    log_system(
331                            "$cvs commit -m '$msg' '" . join( "' '", @_ ) . "'",
332                            "cvs commit of " . join( ",",            @_ ) . " failed"
333                    );
334            }
335    
336            foreach my $p ( @{ $e->{'paths'}->{'path'} } ) {
337                    my ( $action, $path ) = ( $p->{'action'}, $p->{'content'} );
338    
339                    next if ( $path =~ m#/\.svnrev$# );
340    
341                  print "svn2cvs: $action $path\n";                  print "svn2cvs: $action $path\n";
342    
343                  # prepare path and message                  # prepare path and message
344                  my $file = $path;                  my $file = $path;
345                  $path =~ s,^/$SVNREP/*,, || die "BUG: can't strip SVNREP from path";                  if ( $path !~ s#^\Q$SVNREP\E/*## ) {
346                            print
347                                    "NOTICE: skipping '$path' which isn't under repository root '$SVNREP'\n";
348                            die unless $partial_import;
349                            next;
350                    }
351    
352                    if ( !$path ) {
353                            print "NOTICE: skipped this operation. Probably trunk creation\n";
354                            next;
355                    }
356    
357                  my $msg = $e->{'msg'};                  my $msg = $e->{'msg'};
358                  $msg =~ s/"/\\"/g;      # quote "                  $msg =~ s/'/'\\''/g;    # quote "
359    
360                    sub add_path {
361                            my $path = shift || die "no path?";
362    
363                  if ($action =~ /M/) {                          if ( -d $path ) {
364                          print "svn2cvs: modify $path -- nop\n";                                  add_dir( $path, $msg );
365                  } elsif ($action =~ /A/) {                          }
366                          log_system("$cvs add -m \"$msg\" $CVSREP/$path", "cvs add of $path failed");                          elsif ( $path =~ m,^(.+)/[^/]+$, && !-e "$1/CVS/Root" ) {
367                  } elsif ($action =~ /D/) {                                  my $dir = $1;
368                          log_system("$cvs delete -m \"$msg\" $CVSREP/$path", "cvs delete of $path failed");                                  in_entries($dir) || add_dir( $dir, $msg );
369                  } else {                                  in_entries($path) || log_system( "$cvs add '$path'",
370                          print "WARNING: action $action not implemented on $path. Bug or missing feature of $0\n";                                          "cvs add of $path failed" );
371                            }
372                            else {
373                                    in_entries($path) || log_system( "$cvs add '$path'",
374                                            "cvs add of $path failed" );
375                            }
376                  }                  }
377    
378                  # now commit changes                  if ( $action =~ /M/ ) {
379                  log_system("$cvs commit -m \"$msg\" $CVSREP/$path", "cvs commit of $path failed");                          if ( in_entries($path) ) {
380                                    print "svn2cvs: modify $path -- nop\n";
381                            }
382                            else {
383                                    print "WARNING: modify $path which isn't in CVS, adding...\n";
384                                    add_path($path);
385                            }
386                    }
387                    elsif ( $action =~ /A/ ) {
388                            add_path($path);
389                    }
390                    elsif ( $action =~ /D/ ) {
391                            if ( -e $path ) {
392                                    if ( -d $path ) {
393                                            warn "#### remove directory: $path";
394                                            my @sub_commit;
395                                            foreach my $f ( entries($path) ) {
396                                                    $f = "$path/$f";
397                                                    if ( -f $f ) {
398                                                            unlink($f) || die "can't delete file $f: $!";
399    
400                                                      #                                             } else {
401                                                      #                                                     rmtree($f) || die "can't delete dir $f: $!";
402                                                    }
403                                                    log_system( "$cvs delete '$f'",
404                                                            "cvs delete of file $f failed" );
405                                                    push @sub_commit, $f;
406                                            }
407                                            log_system( "$cvs delete '$path'",
408                                                    "cvs delete of file $path failed" );
409                                            cvs_commit( $msg, @sub_commit, $path );
410                                            log_system(
411                                                    "$cvs update -dP '$path'",
412                                                    "cvs update -dP $path failed"
413                                            );
414                                            undef $path;
415                                    }
416                                    else {
417                                            warn "#### remove file: $path";
418                                            unlink($path) || die "can't delete $path: $!";
419                                            log_system( "$cvs delete '$path'",
420                                                    "cvs delete of dir $path failed" );
421                                    }
422                            }
423                            else {
424                                    print "WARNING: $path is not present, skipping...\n";
425                                    undef $path;
426                            }
427                    }
428                    else {
429                            print
430                                    "WARNING: action $action not implemented on $path. Bug or missing feature of $0\n";
431                    }
432    
433                    # save commits for later
434                    push @commit, $path if ($path);
435    
436          }          }
437    
438            # now commit changes
439            cvs_commit( $msg, @commit );
440    
441          commit_svnrev($rev);          commit_svnrev($rev);
442  }  }
443    
444    # cd out of $CVSREP before File::Temp::END is called
445    chdir("/tmp") || die "can't cd to /tmp: $!";
446    
447  __END__  __END__
448    
449  svn export --force "$SVNROOT/$SVNREP" "$CVSREP"  =pod
450    
451  cd dotfiles  =head1 NAME
452    
453  for file in $(find -type f -not -path \*CVS\*); do  svn2cvs - save subversion commits to (read-only) cvs repository
454          FILE=$(basename $file)  
455          DIR=$(dirname $file)  =head1 SYNOPSIS
456          if ! grep -q "^/$FILE/" $DIR/CVS/Entries ; then  
457                  cvs add $file    ./svn2cvs.pl SVN_URL CVSROOT CVSREPOSITORY
458          fi  
459  done  Usage example (used to self-host this script):
460    
461  #cvs commit -m "Automatic commit from SVN"    ./svn2cvs.pl file:///home/dpavlin/private/svn/svn2cvs/trunk/ \
462                   :pserver:dpavlin@cvs.tigris.org:/cvs svn2cvs/src
463  #rm -rf $TMPDIR  
464    =head1 DESCRIPTION
465    
466    This script will allows you to commit changes made to Subversion repository to
467    (read-only) CVS repository manually or from Subversion's C<post-commit> hook.
468    
469    It's using F<.svnrev> file (which will be created on first run) in
470    B<CVSROOT/CVSREPOSITORY> to store last Subversion revision which was
471    committed into CVS.
472    
473    One run will do following things:
474    
475    =over 4
476    
477    =item *
478    checkout B<CVSREPOSITORY> from B<CVSROOT> to temporary directory
479    
480    =item *
481    check if F<.svnrev> file exists and create it if it doesn't
482    
483    =item *
484    loop through all revisions from current in B<CVSROOT/CVSREPOSITORY> (using
485    F<.svnrev>) up to B<HEAD> (current one)
486    
487    =over 5
488    
489    =item *
490    checkout next Subversion revision from B<SVN_URL> over CVS checkout
491    temporary directory
492    
493    =item *
494    make modification (add and/or delete) done in that revision
495    
496    =item *
497    commit modification (added, deleted or modified files/dirs) while
498    preserving original message from CVS
499    
500    =item *
501    update F<.svnrev> to match current revision
502    
503    =back
504    
505    =item *
506    cleanup temporary directory
507    
508    =back
509    
510    If checkout fails for some reason (e.g. flaky ssh connection), you will
511    still have valid CVS repository, so all you have to do is run B<svn2cvs.pl>
512    again.
513    
514    =head1 WARNINGS
515    
516    "Cheap" copy operations in Subversion are not at all cheap in CVS. They will
517    create multiple copies of files in CVS repository!
518    
519    This script assume that you want to sync your C<trunk> (or any other
520    directory for that matter) directory with CVS, not root of your subversion.
521    This might be considered bug, but since common practise is to have
522    directories C<trunk> and C<branches> in svn and source code in them, it's
523    not serious limitation.
524    
525    =head1 RELATED PROJECTS
526    
527    B<Subversion> L<http://subversion.tigris.org/> version control system that is a
528    compelling replacement for CVS in the open source community.
529    
530    B<cvs2svn> L<http://cvs2svn.tigris.org/> converts a CVS repository to a
531    Subversion repository. It is designed for one-time conversions, not for
532    repeated synchronizations between CVS and Subversion.
533    
534    =head1 CHANGES
535    
536    Versions of this utility are actually Subversion repository revisions,
537    so they might not be in sequence.
538    
539    =over 3
540    
541    =item r10
542    
543    First release available to public
544    
545    =item r15
546    
547    Addition of comprehensive documentation, fixes for quoting in commit
548    messages, and support for skipping changes which are not under current
549    Subversion checkout root (e.g. branches).
550    
551    =item r18
552    
553    Support for importing your svn into empty CVS repository (it will first
554    create module and than dump all revisions).
555    Group commit operations to save round-trips to CVS server.
556    Documentation improvements and other small fixes.
557    
558    =item r20
559    
560    Fixed path deduction (overlap between Subversion reporistory and CVS checkout).
561    
562    =item r21
563    
564    Use C<update -d> instead of checkout after import.
565    Added fixes by Paul Egan <paulegan@mail.com> for XMLin and fixing working
566    directory.
567    
568    =item r22
569    
570    Rewritten import from revision 0 to empty repository, better importing
571    of deep directory structures, initial support for recovery from partial
572    commit.
573    
574    =back
575    
576    =head1 AUTHOR
577    
578    Dobrica Pavlinusic <dpavlin@rot13.org>
579    
580    L<https://www.rot13.org/~dpavlin/>
581    
582    =head1 LICENSE
583    
584    This product is licensed under GNU Public License (GPL) v2 or later.
585    
586    =cut
587    
 echo "cvs left in $TMPDIR"  

Legend:
Removed from v.3  
changed lines
  Added in v.41

  ViewVC Help
Powered by ViewVC 1.1.26